#TEMPLATE (ODBCcontrol,'ODBC global'),PRIVATE,FAMILY('ABC')
#EXTENSION(ODBCglobal,'ODBC global extension'),APPLICATION,LAST

#DISPLAY('This must be added before the setup data source')
#DISPLAY('code template can be used. You need to provide the')
#DISPLAY('filename of the lib file which documents the ODBC')
#DISPLAY('functions.')
#DISPLAY('')
#PROMPT('ODBC lib file',OPENDIALOG('ODBC library','Lib file|*.lib')),%ODBClib,REQ
#AT(%CustomGlobalDeclarations)
 #MESSAGE('Adding ODBC library to project',1)
 #PROJECT(%ODBClib)
 #ADD(%CustomGlobalMapModule,%Application & '.clw')
 #ADD(%CustomGlobalMapProcedure,'CDSWrapper')
 #SET(%CustomGlobalMapProcedurePrototype,'(BYTE,BYTE,*CSTRING,*CSTRING),BYTE')
#ENDAT
#AT(%GlobalMap)
    MODULE('ODBC32.DLL')
    SQLFreeHandle(short,ulong),SHORT,RAW,PASCAL,DLL !
    SQLSetEnvAttr(ULONG,SHORT,ULONG,SHORT),SHORT,RAW,PASCAL,DLL !
    SQLAllocHandle(SHORT,ULONG,*ULONG),SHORT,RAW,PASCAL,DLL !
    SQLDataSources(ULONG,USHORT,*CSTRING,SHORT,*SHORT,*CSTRING,SHORT,*SHORT),SHORT,RAW,PASCAL,DLL !
    SQLDrivers(ULONG,USHORT,*CSTRING,SHORT,*SHORT,*CSTRING,SHORT,*SHORT),SHORT,RAW,PASCAL,DLL !
    SQLInstallerError(SHORT,*LONG,*CSTRING,SHORT,*SHORT),SHORT,RAW,PASCAL,DLL !
    SQLConfigDataSource(ULONG,SHORT,*CSTRING,*CSTRING),BYTE,RAW,PASCAL,DLL !
    END
#ENDAT
#AT(%GlobalData)
SQL_SUCCESS EQUATE (0)
SQL_HANDLE_ENV EQUATE (1)
SQL_NULL_HENV EQUATE (0)
SQL_ATTR_ODBC_VERSION EQUATE (200)
SQL_CP_OFF EQUATE (0)
SQL_IS_INTEGER EQUATE (-6)
SQL_FETCH_NEXT EQUATE (1)
SQL_FETCH_FIRST EQUATE (2)
NULL EQUATE (0)
SQL_NO_DATA EQUATE (100)
SQL_SUCCESS_WITH_INFO EQUATE (1)
HENV EQUATE (ULONG)
ADD_DSN EQUATE(1)
CONFIG_DSN  EQUATE(2)
REMOVE_DSN  EQUATE(3)
ADD_SYS_DSN  EQUATE(4)
CONFIG_SYS_DSN  EQUATE(5)
REMOVE_SYS_DSN   EQUATE(6)
REMOVE_DEFAULT_DSN  EQUATE(7)
#ENDAT

#AT(%ProgramProcedures)
CDSWrapper     PROCEDURE  (BYTE display,BYTE request,*CSTRING driver,*CSTRING attrib) ! Declare Procedure
envhandle            HENV
retcode              BYTE
szDSN                CSTRING(33)
szDesc               CSTRING(256)
retval               BYTE
junk1                SHORT
junk2                SHORT
rq                   QUEUE,PRE()
DSNname              CSTRING(32)
descrip              CSTRING(250)
                     END
whandle              ULONG
ecode                LONG
edesc                CSTRING(512)
lerror               SHORT
  CODE
 retval = 1
 whandle = CHOOSE(display,0{PROP:Handle},0)
 if (SQL_SUCCESS <> SQLAllocHandle(SQL_HANDLE_ENV, SQL_NULL_HENV, envhandle) )
   message('failed to get environment handle')
 elsif (SQL_SUCCESS <> SQLSetEnvAttr(envhandle,SQL_ATTR_ODBC_VERSION,3,SQL_IS_INTEGER))
   message('failed to set environment attributes')
 else
   retcode = SQLDrivers(envhandle, SQL_FETCH_FIRST, szDSN, 33,junk1, szDesc, 255, junk2)
   loop while(retcode <> SQL_NO_DATA)
     if(retcode <> SQL_SUCCESS )
       if (retcode <> SQL_SUCCESS_WITH_INFO)
         retval =FALSE
         retcode = SQLINstallerError(1,ecode,edesc,lerror,junk1)
         message('error was ' & edesc)
         break
       end
     end
     rq.DSNname = szDSN
     rq.descrip = szDesc
     add(rq,rq.DSNname)
     retcode = SQLDrivers(envhandle, SQL_FETCH_NEXT, szDSN, 33, junk1, szDesc, 255, junk2)
   end
   junk1=SQLFreeHandle(SQL_HANDLE_ENV, envhandle)
 end
 if retval
   rq.DSNname = driver
   get(rq,rq.DSNname)
   if errorcode()
     message('The driver you specified is not installed on this machine ' & driver)
     retval = 0
   else retval=SQLConfigDataSource(whandle,request,driver,attrib)
     if retval= FALSE
       junk2=SQLInstallerError(1,ecode,edesc,254,junk1)
       if junk2 = SQL_NO_DATA
         message('Unknown error')
       else
         message('Failure from SQLConfigDataSource was ' & clip(edesc) & '.You passed ' & attrib)
       end
     end
   end
 end
 return retval 
#ENDAT 
#!*******END OF GLOBAL EXTENSION*************
#CODE(SetUpDataSource,'Set up ODBC data source'),REQ(ODBCGlobal)
#DISPLAY('Call this procedure with four parameters')
#PROMPT('1. Display Dialog to user',CHECK),%DisplayDialog
#PROMPT('2. Type of request',OPTION),%Reqtype,at(,,130,)
#PROMPT('ADD_DSN',RADIO)
#PROMPT('CONFIG_DSN',RADIO)
#PROMPT('REMOVE_DSN',RADIO)
#PROMPT('ADD_SYS_DSN',RADIO)
#PROMPT('CONFIG_SYS_DSN',RADIO)
#PROMPT('REMOVE_SYS_DSN',RADIO)
#PROMPT('REMOVE_DEFAULT_DSN',RADIO)
#PROMPT('3. Driver string',@s32),%DriverString,AT(65,,210,)
#PROMPT('4. Attribute string ',@s250),%AttrString,at(65,,210,)
#AT(%DataSection)
    #CALL(%MakeDeclr(ABC),22,%OOPConstruct,'CDSretval' & %ActiveTemplateInstance,'BYTE')
%OOPConstruct
    #CALL(%MakeDeclr(ABC),22,%OOPConstruct,'DriverString' & %ActiveTemplateInstance,'CSTRING(33)')
%OOPConstruct    
   #CALL(%MakeDeclr(ABC),22,%OOPConstruct,'AttrString' & %ActiveTemplateInstance,'CSTRING(512)')
%OOPConstruct
#ENDAT
 DriverString%ActiveTemplateInstance='%DriverString'
 AttrString%ActiveTemplateInstance = '%AttrString'
 CDSretval%ActiveTemplateInstance=CDSWrapper(%DisplayDialog,%Reqtype,DriverString%ActiveTemplateInstance,AttrString%ActiveTemplateInstance)

