  member

  include('gjsDup.inc'), once

  map
  end

FindDupClass.init procedure(file f)

  code
  self.qResult &= new ResultQueue
  self.f &= f

FindDupClass.kill procedure

  code
  self.f &= NULL
  dispose(self.qResult)

FindDupClass.buildKeys procedure

i unsigned, auto
k &key

  code
  loop i = 1 to self.f{PROP:Keys}
    k &= self.f{PROP:Key, i}
    build(k)
  end

FindDupClass.findDup procedure

Prog long(0)
Found long(0)

Window WINDOW('Caption'),AT(,,200,44),FONT('MS Sans Serif',8,,FONT:regular),TIMER(1),SYSTEM,GRAY,DOUBLE
       PROGRESS,USE(Prog),AT(5,10,190,10),RANGE(0,100)
       PROMPT('Duplicates:'),AT(5,27)
       BUTTON('&Cancel'),AT(150,25,45,14),USE(?ButtCancel)
       STRING(@s64),AT(50,27),USE(Found)
     END

i unsigned, auto
FinFlag byte(FALSE)

  code
  open(self.f)
  assert(~errorcode())
  stream(self.f)
  assert(~errorcode())
  set(self.f)

  open(window)
  window{PROP:Text} = self.f{PROP:Name}
  ?Prog{PROP:RangeHigh} = records(self.f)
  accept
    case event()
    of EVENT:Timer
      if ~FinFlag
        loop 100 times
          next(self.f)
          if errorcode()
            FinFlag = TRUE
            post(EVENT:CloseWindow)
            break
          end
          Prog += 1; display(?Prog)
          if duplicate(self.f)
            Found += 1; display(?Found)
            self.CalcDupInfo()
          end
        end
      end
    end
  end
  close(window)

  close(self.f)
  return FinFlag

FindDupClass.display procedure

Window WINDOW('Duplicates'),AT(,,300,200),FONT('MS Sans Serif',8,,FONT:regular),SYSTEM,GRAY,DOUBLE
       LIST,AT(5,5,290,190),VSCROLL,FORMAT('115L(2)|M~Record #~@s64@20L(2)~Key~@s64@'),FROM(self.qResult)
     END

  code
  open(window)
  accept
  end
  close(window)

FindDupClass.calcDupInfo procedure

j unsigned, auto
k &key
tmpPos like(ResultQueue.Pos)
tmpPoint long, auto

  code
  tmpPos = position(self.f)
  tmpPoint = pointer(self.f)
  loop j = 1 to self.f{PROP:Keys}
    k &= self.f{PROP:Key, j}
    if duplicate(k)
      get(self.f, k)
      assert(~errorcode())
      self.AddResult(pointer(self.f), k)
      self.AddResult(tmpPoint, k, TRUE)
      reset(self.f, tmpPos)
      next(self.f)
      assert(~errorcode())
    end
  end

FindDupClass.addResult procedure(string pnt, key k, byte AppendPos = FALSE)

  code
  clear(self.qResult)
  self.qResult.Rec = pnt
  self.qResult.Key = k{PROP:Label}
  self.qResult.Pos = position(k)
  get(self.qResult, +self.qResult.Key, +self.qResult.Pos)
  if errorcode()
    add(self.qResult, self.qResult.Rec)
  elsif AppendPos
    self.qResult.Rec = clip(self.qResult.Rec) & ', ' & pnt
    put(self.qResult)
  end

