   MEMBER
!
!         Copyright (c) 1999 Computer Advisors, Inc.
!              P.O Box 538, Prospect, KY 40059
!                     <cai@ntr.net>
!
!   This software is licensed under the terms of the Developers
!   Open Source License. A copy of this license has been
!   included with this source code. The license is also available
!   (as of March 7, 1999) at http://www.clarionmag.com/common/dosl.html
!

_ABCDllMode_  EQUATE(0)
_ABCLinkMode_ EQUATE(1)

  MAP
  END
  INCLUDE('MyClasses.inc'),ONCE

MyFileManager.Fetch PROCEDURE()
ReturnValue BYTE,AUTO
  CODE
  ASSERT(INRANGE(SELF.FetchOnlyType,1,2))
  SELF.Open
  SELF.UseFile(UseType:Benign)
  CASE SELF.FetchOnlyType
  OF FetchMethod:GetByPosition
    GET(SELF.File,1)
    IF ERRORCODE()
      ReturnValue = Level:Notify
    ELSE  
      ReturnValue = Level:Benign
    END
  OF FetchMethod:GetNext
    SET(SELF.File)
    ReturnValue = SELF.Next()
  END
  IF ReturnValue
    CLEAR(SELF.File)
    ReturnValue = SELF.Insert()
  END
  SELF.Close
  RETURN ReturnValue